<?php

chdir('../../');
include(dirname(__FILE__) . "/../../include/global.php");
include_once($config["base_path"] . "/plugins/thold/thold_functions.php");
include_once($config["base_path"] . "/lib/snmp.php");

$global_alert_address = read_config_option("alert_email");
$newLine = "\r\n"; //var for new lines in MS(mail)
	
cacti_log("Checking uptime", true, "UPTIME");

$db = mysql_connect("$database_hostname", "$database_username", "$database_password");
mysql_select_db("$database_default",$db);

$uptimearray = "SELECT * FROM host where uptime = 'on' and disabled <> 'on'";
$queryrows = db_fetch_assoc($uptimearray) or die (mysql_error() );

$uptimearray2 = "SELECT * FROM uptime";
$queryrows2 = db_fetch_assoc($uptimearray2);
		
foreach ($queryrows as $q_row) {
  $old_uptime = "";

  foreach ($queryrows2 as $q_row2) {
    if ($q_row["id"] == $q_row2["id"]) {
      $old_uptime = $q_row2["uptime"];
    }
  }

  if ($old_uptime == "") {
    $old_uptime = "0";
  }
	
  $new_uptime = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.2.1.1.3.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_auth_protocol"], $q_row["snmp_priv_passphrase"], $q_row["snmp_priv_protocol"], $q_row["snmp_context"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
  
  if ($q_row["host_template_id"] == "5") {

	$whyReload = cacti_snmp_get($q_row["hostname"], $q_row["snmp_community"], ".1.3.6.1.4.1.9.2.1.2.0", $q_row["snmp_version"], $q_row["snmp_username"], $q_row["snmp_password"], $q_row["snmp_auth_protocol"], $q_row["snmp_priv_passphrase"], $q_row["snmp_priv_protocol"], $q_row["snmp_context"], $q_row["snmp_port"], $q_row["snmp_timeout"], SNMP_WEBUI);
	} else { 
	$whyReload = "";
	}

  if (($new_uptime == "") || ($new_uptime == "U")) {
    print "Host : " . $q_row["hostname"] . " (" . $q_row["description"] . ") is not responding to SNMP !\n";
  } else {
    print "Host : " . $q_row["hostname"] . " (" . $q_row["description"] . "), old uptime is : " . $old_uptime . ", new is : " . $new_uptime . "\n";	

    db_execute("delete from uptime where id='" . $q_row["id"] . "'"); 	
    db_execute("insert into uptime ( id , uptime ) values ( '" . $q_row["id"] . "' , '" . $new_uptime . "' ) ");

    if ($new_uptime < $old_uptime) {
      cacti_log("Reboot detected of host : " . $q_row["hostname"] , true, "UPTIME");
	  $today = getdate();
      $reboot_date = $today['year']."-".$today['mon']."-".$today['mday']." ".$today['hours'].":".$today['minutes'].":".$today['seconds'];
	  db_execute("insert into uptime_data ( id , datetime, extra ) values ( '" . $q_row["id"] . "' , '" . $reboot_date . "' , '" . $whyReload . "' ) ");
	  thold_mail($global_alert_address, '', 'Reboot detected of host : ' . $q_row["hostname"], 'Host : ' . $q_row["hostname"] . ' (' . $q_row["description"] . '),<br>
Old uptime was : ' . $old_uptime . ' (' . round(($old_uptime)/8640000, 1) . 'd)<br>
New is : ' . $new_uptime . ' (' . round(($new_uptime)/8640000, 1) . 'd)<br>
Reason: ' . $whyReload, '');
    }

  }
 
}

	  
?>
